# Generated by sila2.code_generator; sila2.__version__: 0.12.2
from __future__ import annotations

from typing import Set

from sila2.client import SilaClient
from sila2.framework import FullyQualifiedFeatureIdentifier

from . import (
    cancelcontroller,
    connectionconfigurationservice,
    dataaggregatorcontroller,
    influxdbcontroller,
    measurementcontroller,
    pausecontroller,
    simulationcontroller,
)


class Client(SilaClient):
    CancelController: cancelcontroller.CancelControllerClient

    SimulationController: simulationcontroller.SimulationControllerClient

    ConnectionConfigurationService: connectionconfigurationservice.ConnectionConfigurationServiceClient

    DataAggregatorController: dataaggregatorcontroller.DataAggregatorControllerClient

    MeasurementController: measurementcontroller.MeasurementControllerClient

    InfluxDBController: influxdbcontroller.InfluxDBControllerClient

    PauseController: pausecontroller.PauseControllerClient

    _expected_features: Set[FullyQualifiedFeatureIdentifier] = {
        FullyQualifiedFeatureIdentifier("org.silastandard/core/SiLAService/v1"),
        FullyQualifiedFeatureIdentifier("org.silastandard/core.commands/CancelController/v1"),
        FullyQualifiedFeatureIdentifier("org.silastandard/core/SimulationController/v1"),
        FullyQualifiedFeatureIdentifier("org.silastandard/core/ConnectionConfigurationService/v1"),
        FullyQualifiedFeatureIdentifier("de.unigreifswald/measurements/DataAggregatorController/v1"),
        FullyQualifiedFeatureIdentifier("de.unigreifswald/measurement/MeasurementController/v1"),
        FullyQualifiedFeatureIdentifier("de.unigreifswald/databases/InfluxDBController/v1"),
        FullyQualifiedFeatureIdentifier("org.silastandard/core.commands/PauseController/v2"),
    }

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)

        self._register_defined_execution_error_class(
            cancelcontroller.CancelControllerFeature.defined_execution_errors["InvalidCommandExecutionUUID"],
            cancelcontroller.InvalidCommandExecutionUUID,
        )

        self._register_defined_execution_error_class(
            cancelcontroller.CancelControllerFeature.defined_execution_errors["OperationNotSupported"],
            cancelcontroller.OperationNotSupported,
        )

        self._register_defined_execution_error_class(
            simulationcontroller.SimulationControllerFeature.defined_execution_errors["StartSimulationModeFailed"],
            simulationcontroller.StartSimulationModeFailed,
        )

        self._register_defined_execution_error_class(
            simulationcontroller.SimulationControllerFeature.defined_execution_errors["StartRealModeFailed"],
            simulationcontroller.StartRealModeFailed,
        )

        self._register_defined_execution_error_class(
            connectionconfigurationservice.ConnectionConfigurationServiceFeature.defined_execution_errors[
                "InvalidSiLAClient"
            ],
            connectionconfigurationservice.InvalidSiLAClient,
        )

        self._register_defined_execution_error_class(
            dataaggregatorcontroller.DataAggregatorControllerFeature.defined_execution_errors["AggregationError"],
            dataaggregatorcontroller.AggregationError,
        )

        self._register_defined_execution_error_class(
            measurementcontroller.MeasurementControllerFeature.defined_execution_errors["InvalidCommandExecutionUUID"],
            measurementcontroller.InvalidCommandExecutionUUID,
        )

        self._register_defined_execution_error_class(
            measurementcontroller.MeasurementControllerFeature.defined_execution_errors["InvalidCommandState"],
            measurementcontroller.InvalidCommandState,
        )

        self._register_defined_execution_error_class(
            measurementcontroller.MeasurementControllerFeature.defined_execution_errors["OperationNotSupported"],
            measurementcontroller.OperationNotSupported,
        )

        self._register_defined_execution_error_class(
            measurementcontroller.MeasurementControllerFeature.defined_execution_errors[
                "InvalidFeatureCallConfiguration"
            ],
            measurementcontroller.InvalidFeatureCallConfiguration,
        )

        self._register_defined_execution_error_class(
            pausecontroller.PauseControllerFeature.defined_execution_errors["InvalidCommandExecutionUUID"],
            pausecontroller.InvalidCommandExecutionUUID,
        )

        self._register_defined_execution_error_class(
            pausecontroller.PauseControllerFeature.defined_execution_errors["InvalidCommandState"],
            pausecontroller.InvalidCommandState,
        )

        self._register_defined_execution_error_class(
            pausecontroller.PauseControllerFeature.defined_execution_errors["OperationNotSupported"],
            pausecontroller.OperationNotSupported,
        )
